/*----------------------------------------------------------------------------
 * 
 * file   : help.c 
 * 
 * Author : Yusuf Attarwala
 * Date   : Sep 96
 * 
 *---------------------------------------------------------------------------*/


#include <Xm/DialogS.h>
#include <Xm/MenuShell.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>

#include "globals.h"

static Arg args[40];

Widget createHelpDialog();
void popDownHelp();

static char helpText[] = "\
                    mag2 - texture powered magnification tool.\n\n\
Click on the Snap button and then click anywhere on the screen.\n\
A portion of the screen will appear in the mag2 window.\n\n\
Mouse Controls.\n\
  Left   Mouse   - Pan\n\
  Middle Mouse   - Zoom\n\
  Right  Mouse   - Rotate\n\
  Double click with left mouse to center a pixel.\n\n\
Keyboard Controls.\n\
  Arrows Keys to Pan.\n\
  o key to zoom out\n\
  i key to zoom in \n\
  m key to mark pixel for dimension (see below)\n\
  r key to reset\n\
  s key to snap\n\
  w key to toggle black/white background and grid\n\
  q key to quit\n\
  Escape to quit\n\
  <Ctrl G> toggle grid\n\n\
Dimensioning.\n\
  This feature is useful to compute distance in pixels between any\n\
  two points. Mark the points by placing the cursor on a pixel and\n\
  pressing the 'm' key. On every second point marked, a distance\n\
  is printed in the shell.\n\
";


void
popDownHelp(w,dialog)
Widget w,dialog;
{
    XtUnmanageChild(dialog);
}


Widget
createHelpDialog(parent)
Widget parent;
{
    Widget dialog,workArea;
    Widget stext;
    int i,n;
    Arg args[5];

    n = 0;
    XtSetArg(args[n],XmNautoUnmanage,False);n++;
    XtSetArg(args[n],XmNmarginHeight,1);n++;
    XtSetArg(args[n],XmNtitle,"mag2 Help");n++;
    XtSetArg(args[n],XmNallowResize,False);n++;
    dialog = XmCreatePromptDialog(toplevel,"selecton",args,n);
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_PROMPT_LABEL));
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_COMMAND_TEXT));
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON));

    XtAddCallback(XmSelectionBoxGetChild(dialog,XmDIALOG_OK_BUTTON),
		  XmNactivateCallback,(XtPointer)popDownHelp,dialog);

    workArea = XtVaCreateManagedWidget("workArea", 
                                        xmRowColumnWidgetClass,dialog, 
					XmNmarginHeight,1,
					NULL);

    n = 0;

    XtSetArg(args[n],XmNwordWrap, True);n++;
    XtSetArg(args[n],XmNeditMode,XmMULTI_LINE_EDIT);n++;
    XtSetArg(args[n],XmNrows,30);n++;
    XtSetArg(args[n],XmNcolumns,70);n++;
    XtSetArg(args[n],XmNeditable,False);n++;
    stext = XmCreateScrolledText(workArea,"stext", args,n);
    XtManageChild(stext);

    XmTextSetString(stext,helpText);

    return dialog;
}

void
helpCB()
{
    XtManageChild(helpDialog);
}

