/*----------------------------------------------------------------------------
 *
 * file   : main.c for mag2
 *
 * Author : Yusuf Attarwala
 * Date   : Oct 96
 *
 *---------------------------------------------------------------------------*/
#include <stdio.h>

#define DEFINE_GLOBALS 1
#include "globals.h"
#undef DEFINE_GLOBALS
#include <Xm/DialogS.h>

/* currently commandline args not used, 
   but this is a place holder for future enhancements */

typedef struct _cmdLine {
    String     status;           
} CmdLine, *CmdLinePtr;

CmdLine commandLine;

static XtResource resources[] = {
    {"status",    "Status",   XtRString,  sizeof(String),
      XtOffset(CmdLinePtr,status), XtRString, "0",},
};

static XrmOptionDescRec options[] = {
    {"-s",      "status",  XrmoptionSepArg, NULL},
};

static String fallbackResources[] = {
    "*useSchemes:                  all",
    "*sgiMode:                     true",
    "*background:                  grey",
    /*
    "*XmLabel.traversalOn:         False",
    */
    "*fillOnSelect:                True",
    "*selectColor:                 yellow",
    "*menub*fontList:              -adobe-helvetica-*-o-normal-*-14-*-*-*-*-*-*-*",
    "*Xmlabel*fontList:            -adobe-helvetica-*-o-normal-*-12-*-*-*-*-*-*-*",
    "*label*fontList:              -adobe-helvetica-*-o-normal-*-12-*-*-*-*-*-*-*",
/*
    "*label.fontList:             SGI_DYNAMIC PlainLabelFont",
*/
    NULL
};

#define LATER
/* function declaration */
void main();
static void initX(),
	    initGlobals();

extern void doZoom(Picture *, float, float);
extern void grabImage(Picture *, int, int);
void
main(argc,argv)
int argc;
char **argv;
{
    initX(argc,argv);
    initGlobals();
    createUI();

#ifdef LATER /* { */
    canvas.doubleBuffer = 1;
    enableSingleBuffer(&canvas);
#endif/*LATER } */
    grabImage(&canvas,400,400);
    doZoom(&canvas,140.0,140.0/canvas.waspect);

    XtAppMainLoop(appContext);
}

static void
initX(argc,argv)
int argc;
char **argv;
{
    int n;
    Arg alist[25];
    XFontStruct *genericFont;

    n = 0;
    /*
    XtSetArg(alist[n],XmNmappedWhenManaged,False); n++;
    XtSetArg(alist[n],XmNminAspectX,  1);n++;
    XtSetArg(alist[n],XmNminAspectY,  1);n++;
    XtSetArg(alist[n],XmNmaxAspectX,  1);n++;
    XtSetArg(alist[n],XmNmaxAspectY,  1);n++;
    */
    XtSetArg(alist[n],XmNkeyboardFocusPolicy,XmPOINTER);n++;
    XtSetArg(alist[n],XmNtitle,  "mag2");n++;
    topmostlevel = XtAppInitialize(&appContext,"Mag2",
                               options,XtNumber(options),
                               &argc,argv,
                               fallbackResources,
                               alist, n);

    /* make a transient shell to avoid window manager intervention later on */

    n = 0;
    XtSetArg(alist[n],XmNminWidth,132);n++;
    XtSetArg(alist[n],XmNminHeight,100);n++;
    toplevel = XtCreatePopupShell("toplevel",transientShellWidgetClass,
				   topmostlevel,alist,n);

    /* cache the usual stuff into globals */
    display    = XtDisplay(toplevel);
    screen     = XDefaultScreen(display);
    rootWindow = DefaultRootWindow(display);
    XtGetApplicationResources(toplevel,&commandLine,
                              resources,XtNumber(resources),
                              NULL,0);

    screenHeight  = DisplayHeight(display,screen);
    screenWidth   = DisplayWidth (display,screen);

    /* save few useful colors */
    {
	XColor temp;
	Colormap cmap = XDefaultColormap(display,screen);
        XAllocNamedColor(display,cmap,"red",  &temp,&redColor);
        XAllocNamedColor(display,cmap,"aquamarine",&temp,&greenColor);
        XAllocNamedColor(display,cmap,"black",&temp,&blackColor);
        XAllocNamedColor(display,cmap,"white",&temp,&whiteColor);
        XAllocNamedColor(display,cmap,"grey", &temp,&greyColor);
        XAllocNamedColor(display,cmap,"red4", &temp,&brownColor);
    }


    /* keep some fonts handy */
    genericFont = XLoadQueryFont(display,"9x15");
    if (!(mediumNormalFont = XLoadQueryFont(display,
                   "-adobe-helvetica-medium-r-normal-*-14-*-*-*-*-*-*-*")))
    mediumNormalFont = genericFont;

    /* create and save cursors */
    createCursors();

}

static void
initGlobals()
{
}

